local getExposure
local getContrast
local getTemperature
local getSaturation
local getVibrance
local getBrightness

local function UI()
  local dialog
  dialog = GUI.createDialog{
    icon = Icon.REGION,
    title = 'Settings',
    height = 280
  }
    
  local layout = dialog.content:addLayout{
    vertical = true
  }
  
  local function addLine(label, height)
    local line = layout:addLayout{height = height}
    line:addLabel{text = label, w = 60}
    return line:addLayout{ x = 62 }
  end
    
  local line0 = addLine('Exposure:', 26)
  line0:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getExposure = v,
      Drawing.setUniform("sio4Exposure", getExposure)
    end,
    getValue = function() return getExposure end
  }
    
  local line1 = addLine('Contrast:', 26)
  line1:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getContrast = v,
      Drawing.setUniform("sio4Contrast", getContrast)
    end,
    getValue = function() return getContrast end
  }
    
  local line2 = addLine('Temperature:', 26)
  line2:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getTemperature = v,
      Drawing.setUniform("sio4Temperature", getTemperature)
    end,
    getValue = function() return getTemperature end
  }
    
  local line3 = addLine('Saturation:', 26)
  line3:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getSaturation = v,
      Drawing.setUniform("sio4Saturation", getSaturation)
    end,
    getValue = function() return getSaturation end
  }
    
  local line4 = addLine('Vibrance:', 26)
  line4:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getVibrance = v,
      Drawing.setUniform("sio4Vibrance", getVibrance)
    end,
    getValue = function() return getVibrance end
  }
    
  local line5 = addLine('Brightness:', 26)
  line5:addSlider{
    minValue = -2,
    maxValue = 2,
    setValue = function(v) 
      getBrightness = v,
      Drawing.setUniform("sio4Brightness", getBrightness)
    end,
    getValue = function() return getBrightness end
  }
    
  local line6 = addLine('Attention:', 20)
  line6:addTextFrame{
    text = "The adjustments won't save"
  }
    
  local line7 = addLine('', 20)
  line7:addTextFrame{
    text = "For more infomation, please visit"
  }
    
local line = addLine('Click >>>>', 20)
  local textField = line:addTextField{
    text = "https://forum.theotown.com/viewtopic.php?t=26220",
    w = -40
  }
  
  closeDialog = dialog.close
end

function script:init()
  if closeDialog then
    closeDialog()
    closeDialog = nil
    UI()
  end
end

function script:event(_, _, _, event)
  if event == Script.EVENT_TOOL_ENTER then
    GUI.get('cmdCloseTool'):click()
    UI()
  end
end